	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE sound.h
	INCLUDE 6502.h

	IMPORT C_entry	;from main.c

	EXPORT IO_R
	EXPORT IO_W

 AREA wram_code1, CODE, READWRITE ;-- - - - - - - - - - - - - - - - - - - - - -
;----------------------------------------------------------------------------
IO_R		;I/O read
;----------------------------------------------------------------------------
	ldr r1,=0x4015
	cmp addy,r1
	beq _4015r
	b empty_R
;----------------------------------------------------------------------------
IO_W		;I/O write
;----------------------------------------------------------------------------
	sub r2,addy,#0x4000
	cmp r2,#0x17
	bhi empty_W
	adr r1,io_write_tbl
	ldr pc,[r1,r2,lsl#2]
io_write_tbl
	DCD _4000w
	DCD _4001w
	DCD _4002w
	DCD _4003w
	DCD _4004w
	DCD _4005w
	DCD _4006w
	DCD _4007w
	DCD _4008w
	DCD void
	DCD _400aw
	DCD _400bw
	DCD _400cw
	DCD void
	DCD _400ew
	DCD _400fw
	DCD _4010w
	DCD void
	DCD _4012w
	DCD _4013w
	DCD void	;$4014: Sprite DMA transfer
	DCD _4015w
	DCD void	;$4016: Joypad 0 write
	DCD void	;$4017: ?
;--------------------------------------------------
	INCLUDE visoly.s
	END
