org $5080

CURRENT = $100  ;song#
PLAYING = $101  ;nonzero=song is playing
JOYPAD  = $102  ;button state
JOYD    = $103  ;button 0->1
FRAME   = $104
DIVTMP  = $105
STR     = $106

SONGS   = $5006
FIRST   = $5007

A       = $80
B       = $40
SELECT  = $20
START   = $10
UP      = $08
DOWN    = $04
LEFT    = $02
RIGHT   = $01

reset ;------------------
        sei                     ;etc etc
        ldx #$ff
        txs

        lda #$00                ;screen off
        sta $2000
        sta $2001

        ldx #7                  ;init banks
-       lda $5070,x
        sta $5ff8,x
        dex
        bpl -

	.db $FF

pad $50a0
play ;--------------------
	jsr playhere
	db $FF
playhere
        jmp ($500c)             ;jmp (PLAY)

pad $50c0
init ;------------------        ;begin CURRENT song
        pha

        lda #0                  ;clear 0000-07ff
        tax
-       sta $00,x
        sta $200,x              ;(not 100-1ff)
        sta $300,x
        sta $400,x
        sta $500,x
        sta $600,x
        sta $700,x
        inx
        bne -

        jsr stopsound

        pla
        ldx #$00

	jsr inithere
	db $FF
inithere
        jmp ($500a)

stopsound ;---------------
        lda #$00                ;reset sound regs
        sta $4015
        sta $4008
        lda #$10
        sta $4000
        sta $4004
        sta $400c
        lda #$0f
        sta $4015
        rts
;------------------------
  align 4
.end
