	AREA rom_code, CODE, READONLY
	ENTRY

	INCLUDE equates.h

	IMPORT |Image$$RO$$Base|
	IMPORT |Image$$RO$$Limit|
	IMPORT |Image$$RW$$Base|
	IMPORT |Image$$RW$$Limit|
	IMPORT |Image$$ZI$$Base|
	IMPORT |Image$$ZI$$Limit|

	IMPORT C_entry	;from main.c
	IMPORT textstart

;----------------------------------------------------------
__main
;----------------------------------------------------------
	ldr	sp,=0x3007f00
	LDR	r5,=|Image$$RO$$Limit| ;r5=pointer to IWRAM code

	ldr r0,=|Image$$RO$$Limit|
	ldr r1,=|Image$$RW$$Limit|

	add r1,r1,r0
	sub r6,r1,#0x3000000		;r6=textstart

	adr lr,_3
	tst lr,#0x8000000
	beq _3				;running from cart?
		add r6,r6,#0x6000000		;textstart=8xxxxxx
		add r5,r5,#0x6000000		;RW code ptr=8xxxxxx

		ldr r1,=|Image$$RO$$Base|	;copy rom code to exram
		add r0,r1,#0x6000000
		ldr r3,=|Image$$RO$$Limit|
_2		cmp r1,r3
		ldrcc r2, [r0], #4
		strcc r2, [r1], #4
		bcc _2
		sub pc,lr,#0x6000000	;jump to exram copy
_3
	LDR	r1, =|Image$$RW$$Base|
	LDR	r3, =|Image$$ZI$$Base| ; Zero init base => top of initialized data
_0	CMP	r1, r3
	LDRCC	r2, [r5], #4		;copy RW code to IWRAM
	STRCC	r2, [r1], #4
	BCC	_0
	LDR	r1, =|Image$$ZI$$Limit| ; Top of zero init segment
	MOV	r2, #0
_1	CMP	r3, r1 ; Zero init
	STRCC	r2, [r3], #4
	BCC	_1

	ldr r4,=textstart	;textstart=ptr to NES rom info
	str r6,[r4]

	mov r0,#0x14
	ldr r1,=REG_WSCNT
	strh r0,[r1]		;3/1 wait state

	b C_entry
;----------------------------------------------------------
	END
